var fs = require('fs');

function deleteFolderRecursive(path) {
  if (fs.existsSync(path) && fs.lstatSync(path).isDirectory()) {
    fs.readdirSync(path).forEach(function(file, index) {
      var curPath = path + '/' + file;

      if (fs.lstatSync(curPath).isDirectory()) {
        deleteFolderRecursive(curPath);
      } else {
        fs.unlinkSync(curPath);
      }
    });

    console.log(`Deleting directory "${path}"...`);
    fs.rmdirSync(path);
  }
}

console.log('Cleaning working tree...');
deleteFolderRecursive('./server/out');
deleteFolderRecursive('./server/dist');
deleteFolderRecursive('./clients/vscode/out');
console.log('Successfully cleaned working tree!');
